;*---------------------------------------------------------------------*/
;*    Copyright (c) 1994 by Manuel Serrano. All rights reserved.       */
;*                                                                     */
;*                                     ,--^,                           */
;*                               _ ___/ /|/                            */
;*                           ,;'( )__, ) '                             */
;*                          ;;  //   L__.                              */
;*                          '   \    /  '                              */
;*                               ^   ^                                 */
;*                                                                     */
;*                                                                     */
;*    This program is distributed in the hope that it will be useful.  */
;*    Use and copying of this software and preparation of derivative   */
;*    works based upon this software are permitted, so long as the     */
;*    following conditions are met:                                    */
;*           o credit to the authors is acknowledged following         */
;*             current academic behaviour                              */
;*           o no fees or compensation are charged for use, copies,    */
;*             or access to this software                              */
;*           o this copyright notice is included intact.               */
;*      This software is made available AS IS, and no warranty is made */
;*      about the software or its performance.                         */
;*                                                                     */
;*      Bug descriptions, use reports, comments or suggestions are     */
;*      welcome Send them to                                           */
;*        <Manuel.Serrano@inria.fr>                                    */
;*        Manuel Serrano                                               */
;*        INRIA -- Rocquencourt                                        */
;*        Domaine de Voluceau, BP 105                                  */
;*        78153 Le Chesnay Cedex                                       */
;*        France                                                       */
;*---------------------------------------------------------------------*/


;; Le module                                                                 
(module
  __caml_pair
  (foreign (include #"caml-bigloo.h"))
  (import)
  (export
    (split_219@pair x1)
    (combine_207@pair x1)
    (map_combine_74@pair x1)
    (2-155-map_combine_74@pair x1 x3)
    (do_list_combine_121@pair x1)
    (2-195-do_list_combine_121@pair x1 x3)))
;; L'initialisation du module                                                
(init_camloo!)
;; Les variables globales                                                    
;; Les expressions globales                                                  
(define split_219@pair
  (lambda (x1)
    (if (null? x1)
      (caml-make-regular (caml-make-tag 0 1) 2 '() '())
      (let ((x2 (split_219@pair (cdr x1))))
        (caml-make-regular
          (caml-make-tag 0 1)
          2
          (cons (caml-constr-get-field (car x1) 0)
                (caml-constr-get-field x2 0))
          (cons (caml-constr-get-field (car x1) 1)
                (caml-constr-get-field x2 1)))))))

(define combine_207@pair
  (lambda (x1)
    (labels
      ((staticfail1000
         ()
         (invalid_arg_209@exc #"combine")))
      (if (null? (caml-constr-get-field x1 0))
        (if (null? (caml-constr-get-field x1 1))
          '()
          (staticfail1000))
        (if (null? (caml-constr-get-field x1 1))
          (staticfail1000)
          (cons (caml-make-regular
                  (caml-make-tag 0 1)
                  2
                  (car (caml-constr-get-field x1 0))
                  (car (caml-constr-get-field x1 1)))
                (combine_207@pair
                  (caml-make-regular
                    (caml-make-tag 0 1)
                    2
                    (cdr (caml-constr-get-field x1 0))
                    (cdr (caml-constr-get-field x1 1))))))))))

(begin
  (define map_combine_74@pair
    (lambda (x1)
      (lambda (x3) (2-155-map_combine_74@pair x1 x3))))
 (define 2-155-map_combine_74@pair
    (lambda (x1 x3)
      (letrec ((x2 (lambda (x3)
                     (labels
                       ((staticfail1001
                          ()
                          (invalid_arg_209@exc #"map_combine")))
                       (if (null? (caml-constr-get-field x3 0))
                         (if (null? (caml-constr-get-field x3 1))
                           '()
                           (staticfail1001))
                         (if (null? (caml-constr-get-field x3 1))
                           (staticfail1001)
                           (cons (x1 (caml-make-regular
                                       (caml-make-tag 0 1)
                                       2
                                       (car (caml-constr-get-field x3 0))
                                       (car (caml-constr-get-field x3 1))))
                                 (x2 (caml-make-regular
                                       (caml-make-tag 0 1)
                                       2
                                       (cdr (caml-constr-get-field x3 0))
                                       (cdr (caml-constr-get-field
                                              x3
                                              1)))))))))))
        (x2 x3))))
)
(begin
  (define do_list_combine_121@pair
    (lambda (x1)
      (lambda (x3)
        (2-195-do_list_combine_121@pair x1 x3))))
 (define 2-195-do_list_combine_121@pair
    (lambda (x1 x3)
      (letrec ((x2 (lambda (x3)
                     (labels
                       ((staticfail1002
                          ()
                          (invalid_arg_209@exc #"do_list_combine")))
                       (if (null? (caml-constr-get-field x3 0))
                         (if (null? (caml-constr-get-field x3 1))
                           (caml-make-tag 0 1)
                           (staticfail1002))
                         (if (null? (caml-constr-get-field x3 1))
                           (staticfail1002)
                           (begin
                             (x1 (caml-make-regular
                                   (caml-make-tag 0 1)
                                   2
                                   (car (caml-constr-get-field x3 0))
                                   (car (caml-constr-get-field x3 1))))
                             (x2 (caml-make-regular
                                   (caml-make-tag 0 1)
                                   2
                                   (cdr (caml-constr-get-field x3 0))
                                   (cdr (caml-constr-get-field x3 1)))))))))))
        (x2 x3))))
)
